#include "radixtree.h"

void Radixtree::removeNodes(node* nd) {
  if (nd->left)
	removeNodes(nd->left);
  if (nd->right)
	removeNodes(nd->right);
  delete nd;
}

void Radixtree::add_element(vector<bool>& elem) {
  node *index = root;
  for (int i = 0; i < depth; i++) {
	if (elem[i]) {
	  if (!index->left)
		index->left = new node;
	  index = index->left;
	}
	else {
	  if (!index->right)
		index->right = new node;
	  index = index->right;
	}
  }
}

bool Radixtree::contains_element(vector<bool>& elem) {
  node *index = root;
  for (int i = 0; i < depth; i++) {
	if (elem[i])
	  if (!index->left)
		return false;
	  else
		index = index->left;
	else
	  if(!index->right)
		return false;
	  else
		index = index->right;
  }
  return true;
}

int Radixtree::size_intern(int d, node* nd) {
  int size = 0;
  if (!d)
	size = 1;
  else {
	if (nd->left) 
	  size += size_intern(d-1, nd->left);
	if (nd->right)
	  size += size_intern(d-1, nd->right);
  }
  return size;
}
