#ifndef RADIXTREE_HH
#define RADIXTREE_HH

#include <vector>

using namespace std;

class Radixtree {
	private:
		typedef struct nd {
		  struct nd *left;
		  struct nd *right;
		  nd() { left = right = NULL; };
		} node;

		int depth;
		node *root;

		void removeNodes(node* nd);
		int size_intern(int d, node* nd);

	public:
		Radixtree(int n) {
			depth = n;
			root = new node();
		};

		~Radixtree(){ removeNodes(root); };

		int size() { return size_intern(depth, root); };
		void clear() { removeNodes(root); root = new node(); };
		void add_element(vector<bool>& elem);
		bool contains_element(vector<bool>& elem);
};

#endif
