#ifndef SETOFCONCLUSIONS_H
#define SETOFCONCLUSIONS_H


#include <vector>

#include <stdio.h>
#include <cmath>

#include "glpk.h"
#include "bdd.h"

#include "../formulas/rational.h"
#include "valuation.h"


using namespace std;

typedef vector<TruthAssignment> Conclusion;

class SetOfConclusions{
	private:
		int no_of_literals;
		vector<Conclusion> rules;

	public:
		SetOfConclusions(){no_of_literals = 0;};
		SetOfConclusions(int n, const vector<vector<bool> >& set);
		
		int number_of_conclusions(){return rules.size();};		
		bdd get_jth_conclusion(bdd** underlying, int j);
		
		
		
		
		//bdd get_ith_conclusion(int i, bdd* bddarray);
};
#endif
