#include "valuation.h"

Valuation::Valuation(int i, int no_of_vars){
        int limit = 1 << no_of_vars;
        if(i >= limit){
          cout << "cannot make clause " << i << " out of " << limit << endl;
}
	n = no_of_vars;
	
	p = new int [n];
	
	int ui = i;	
	
	for(int j=0; j < no_of_vars; j++){
		p[j] = ui & 1;
		ui >>=1;
	}
	
}
	

Valuation::Valuation(int _n, int* _p){
	n = _n;
	p = new int [n];
	
	for(int i=0; i < n; i++)
		p[i]=_p[i];
}	

Valuation::Valuation(const Valuation& c){
	n = c.n;
	p = new int [n];
	
	for(int i=0; i < n; i++)
		p[i]=c.p[i];
}

Valuation& Valuation::operator=(const Valuation& c){
	if(this != &c){
		if(p)
			delete [] p;
		n = c.n;
		p = new int [n];
	
		for(int i=0; i < n; i++)
			p[i]=c.p[i];
	}
	return *this;
}


Valuation::~Valuation(){
	if(p)
		delete [] p;
}

int Valuation::get_p_i(int i){
	if(p)
		return p[i];
	return -1;
}

bool Valuation::operator==(const Valuation& other) const{
		if(n == other.n){
			for(int i = 0; i < n; i++)
				if(p[i]!=other.p[i])
					return false;
			return true;
		}
		return false;
		}
